//JD encoder reader for AIO
//2023 05 01 by Pat

//Pinout:
//GND to AIO GND
//5V to 5V WAS (AIO)
//D4 to encoder first signal (with 10k res for safety) probably should be 50k, to test
//D7 to second encoder signal (with 10k res for safety) probably should be 50k, to test
//D9 to output (to AIO remote pin) (with 100 ohm res for safety) probably should be 330 or 1k ohm, to test

const uint8_t encA = 4;
const uint8_t encB = 7;
const uint8_t outPin = 9;

uint8_t encAstate = LOW;
uint8_t encBstate = LOW;
uint8_t lastencAstate = LOW;
uint8_t lastencBstate = LOW;
uint8_t encoderState = 1;
uint8_t lastencoderState = 1;
uint8_t preLastencoderState = 1;

bool outHigh = false;



void setup() {
  // put your setup code here, to run once:
  pinMode(encA, INPUT);
  pinMode(encB, INPUT);
  pinMode(outPin, OUTPUT);
}

void loop() {
  // put your main code here, to run repeatedly:

  encAstate = digitalRead(encA);
  encBstate = digitalRead(encB);

  //if there is a change in the input states do something
  if (encAstate != lastencAstate || encBstate != lastencBstate) {
    if (encAstate == LOW) {
      if (encBstate == LOW) encoderState = 1;
      else encoderState = 4;
    } else {
      if (encBstate == LOW) encoderState = 2;
      else encoderState = 3;
    }

    //if it's moving in the same direction change the output
    if (encoderState != preLastencoderState) {
      outHigh = !outHigh;
      digitalWrite(outPin, outHigh);
    }
    preLastencoderState = lastencoderState;
    lastencoderState = encoderState;
  }
  lastencAstate = encAstate;
  lastencBstate = encBstate;
}
